/*SpUpd!_2021.02.05_0000005*/
/*needVer=2021.02.04_0000004*/

UPDATE COP_KF SET 
    MKB = 'D61.1'
WHERE (MKB = 'D61.5') AND
      (TS = 1) AND
      (KF = 1.5) AND
      (GRP = 0) AND
      (DBEG = '2021-01-01 00:00:00');
@
UPDATE SPR_CRITERIES SET 
    DATEEND = null
WHERE (CODE = 'fr01-05') AND
      (DATEBEG = '2019-01-01 00:00:00') AND
      (DATEEND = '2020-12-31 00:00:00');
@
UPDATE SPR_CRITERIES SET 
    DATEEND = null
WHERE (CODE = 'fr06-07') AND
      (DATEBEG = '2019-01-01 00:00:00') AND
      (DATEEND = '2020-12-31 00:00:00');
@
UPDATE SPR_CRITERIES SET 
    DATEEND = null
WHERE (CODE = 'fr08-10') AND
      (DATEBEG = '2019-01-01 00:00:00') AND
      (DATEEND = '2020-12-31 00:00:00');
@
UPDATE SPR_CRITERIES SET 
    DATEEND = null
WHERE (CODE = 'fr11-20') AND
      (DATEBEG = '2019-01-01 00:00:00') AND
      (DATEEND = '2020-12-31 00:00:00');
@
UPDATE SPR_CRITERIES SET 
    DATEEND = null
WHERE (CODE = 'fr21-29') AND
      (DATEBEG = '2019-01-01 00:00:00') AND
      (DATEEND = '2020-12-31 00:00:00');
@
UPDATE SPR_CRITERIES SET 
    DATEEND = null
WHERE (CODE = 'fr30-32') AND
      (DATEBEG = '2019-01-01 00:00:00') AND
      (DATEEND = '2020-12-31 00:00:00');
@
UPDATE SPR_CRITERIES SET 
    DATEEND = null
WHERE (CODE = 'fr33-99') AND
      (DATEBEG = '2019-01-01 00:00:00') AND
      (DATEEND = '2020-12-31 00:00:00');
@
CREATE OR ALTER procedure SP_RMTLDETAIL (
    PID_ILL integer,
    PONDATE date)
returns (
    RID integer,
    RNMTL integer,
    RPROF integer,
    RPROFNAME varchar(254),
    RDIAG varchar(7),
    RKOD_MES varchar(20),
    RDOCDO char(13),
    RKURACIA char(12),
    RINTENSIVE char(3),
    RINTERRUPT char(3),
    RKDMES integer,
    RKDSVMES integer,
    RKDNOT integer,
    RKD integer,
    RKDMESSROK integer,
    ROCNCOST numeric(15,2),
    RDOPCOST numeric(15,2),
    ROPLAT smallint,
    RCOST numeric(15,2),
    REXTREN char(3),
    RKDFMTL integer,
    VID_RASCHETA char(3),
    RKDOMS smallint,
    RSTAN_LECEN smallint,
    RSTAN_OBSL smallint,
    RSROK smallint,
    RKSG varchar(20),
    ISHOD_NAME varchar(15),
    RESULT_NAME varchar(100))
as
declare variable IID_ILL integer;
declare variable INMTL integer;
declare variable IDIAG varchar(7);
declare variable IKOD_MES varchar(20);
declare variable IACCOMP1 varchar(7);
declare variable IMES_ACC1 varchar(20);
declare variable IACCOMP_L1 integer;
declare variable IACCOMP2 varchar(7);
declare variable IMES_ACC2 varchar(20);
declare variable IACCOMP_L2 integer;
declare variable IACCOMP3 varchar(7);
declare variable IMES_ACC3 varchar(20);
declare variable IACCOMP_L3 integer;
declare variable IKURACIA integer;
declare variable IINTENSIVE integer;
declare variable IINTERRUPT integer;
declare variable ICOP1COST numeric(15,2);
declare variable ICOP2COST numeric(15,2);
declare variable ICOP3COST numeric(15,2);
declare variable ICOST numeric(15,2);
declare variable IKD integer;
declare variable IKDMESSROK integer;
declare variable ISROK1 integer;
declare variable ISROK2 integer;
declare variable ISROK3 integer;
declare variable IEXTREN integer;
declare variable ISTAN_LECEN integer;
declare variable ISTAN_OBSL integer;
declare variable V_ISHOD smallint;
declare variable V_RSLT smallint;
declare variable SECONDARY_DIAG varchar(7);
declare variable S_DIAG_STATUS smallint;
declare variable MTL_ID integer;
begin
FOR SELECT ID, ID_ILL, mtl.id, NOM_MTL, profil_bed, PROFIL.NAME, STAC_DIAG, KOD_MES,
ACCOMP1, MES_ACC1, ACCOMP_L1,
ACCOMP2, MES_ACC2, ACCOMP_L2,
ACCOMP3, MES_ACC3, ACCOMP_L3,
MTL.KURACIA, INTENSIV, INTERRUPT,
KDMES, KDSVMES, KDNOT, KD, kdoms, MES0.SROK, (mtl.ocncost- coalesce(mtl.mod_ffoms_cost,0)- coalesce(mtl.mod_tfoms_cost,0)) OCNCOST,
DOPCOST, COP1COST, COP2COST, COP3COST, MES1.SROK, MES2.SROK, MES3.SROK, OPLAT, EXTREN, KDFMTL, STAN_LECEN, STAN_OBSL, KSG_ID,
ISHOD, RSLT FROM MTL
LEFT JOIN PROFIL ON MTL.profil_bed = PROFIL.TIP_PROF
LEFT JOIN MES MES0 ON MTL.KOD_MES = MES0.KOD AND MES0.DATEFROM <= :pOnDate AND (MES0.DATETO >= :pondate OR MES0.DATETO IS NULL)
LEFT JOIN MES MES1 ON MTL.MES_ACC1 = MES1.KOD AND MES1.DATEFROM <= :pOnDate AND (MES1.DATETO >= :pondate OR MES1.DATETO IS NULL)
LEFT JOIN MES MES2 ON MTL.MES_ACC2 = MES2.KOD AND MES2.DATEFROM <= :pOnDate AND (MES2.DATETO >= :pondate OR MES2.DATETO IS NULL)
LEFT JOIN MES MES3 ON MTL.MES_ACC3 = MES3.KOD AND MES3.DATEFROM <= :pOnDate AND (MES3.DATETO >= :pondate OR MES3.DATETO IS NULL)
WHERE :pID_ILL = ID_ILL
INTO rID, iID_ILL, :MTL_ID, iNMTL, rPROF, rPROFNAME, iDIAG, iKOD_MES,
iACCOMP1, iMES_ACC1, iACCOMP_L1,
iACCOMP2, iMES_ACC2, iACCOMP_L2,
iACCOMP3, iMES_ACC3, iACCOMP_L3,
iKURACIA, iINTENSIVE, iINTERRUPT,
rKDMES, rKDSVMES, rKDNOT, iKD, rkdoms, iKDMESSROK, rOCNCOST, rDOPCOST, iCOP1COST,
iCOP2COST, iCOP3COST, iSROK1, iSROK2, iSROK3, rOPLAT, iEXTREN, RKDFMTL,iSTAN_LECEN,iSTAN_OBSL,RKSG,
V_ISHOD, V_RSLT DO
BEGIN
rsrok=ikdmessrok;
rstan_lecen=istan_lecen;
rstan_obsl=istan_obsl;
IF (NOT ((iSTAN_LECEN in (1,4)) And (iSTAN_OBSL in (1,4)))) THEN
VID_RASCHETA = '';
ELSE VID_RASCHETA = '';
rEXTREN = ' ? ';
IF (iEXTREN = 0) THEN rEXTREN = '';
ELSE IF (iEXTREN = 1) THEN rEXTREN = '';
ELSE rEXTREN = cast(iEXTREN as char(3));
rNMTL = iNMTL;
rDIAG = iDIAG;
rKOD_MES = iKOD_MES;
rDOCDO = ' - ';
rKDMESSROK = iKDMESSROK;
ISHOD_NAME = (select i.izname from ishod_fed i where i.idiz = :v_ishod and :pOnDate between i.datebeg and coalesce(i.dateend, '31.12.9999'));
RESULT_NAME = (select rs.rmpname from result_fed rs where rs.idrmp = :v_rslt and :pOnDate between rs.datebeg and coalesce(rs.dateend, '31.12.9999'));
rKURACIA = ' ';
IF (iKURACIA = 1) THEN rKURACIA = '';
ELSE IF (iKURACIA = 2) THEN rKURACIA = '. ';
ELSE IF (iKURACIA = 3) THEN rKURACIA = '';
rINTENSIVE = ' ? ';
IF (:PONDATE < '01.08.04') THEN
BEGIN
IF (iINTENSIVE = 0) THEN rINTENSIVE = '';
ELSE IF (iINTENSIVE = 1) THEN rINTENSIVE = '';
END ELSE rINTENSIVE = cast(iINTENSIVE as char(3));
rINTERRUPT = ' ? ';
IF (iINTERRUPT = 0) THEN rINTERRUPT = '';
ELSE IF (iINTERRUPT = 1) THEN rINTERRUPT = '';
IF (iCOP1COST is null) THEN iCOP1COST = 0;
IF (iCOP2COST is null) THEN iCOP2COST = 0;
IF (iCOP3COST is null) THEN iCOP3COST = 0;
IF (rDOPCOST is null) THEN rDOPCOST = 0;
iCOST = rOCNCOST + iCOP1COST + iCOP2COST + iCOP3COST;
rCOST = rOCNCOST;
IF (rKDMES is null) THEN rKDMES = 0;
IF (rKDSVMES is null) THEN rKDSVMES = 0;
IF (rKDNOT is null) THEN rKDNOT = 0;
IF (iKD is null) THEN iKD = 0;
rKD = iKD;
suspend;
--rNMTL = null;
rPROF = null;
rPROFNAME = null;
rDOCDO = null;
rKURACIA = null;
rINTENSIVE = null;
rINTERRUPT = null;
rKDMES = null;
rKDSVMES = null;
rKDNOT = null;
rKD = null;
rKDMESSROK = null;
rOCNCOST = null;
rDOPCOST = null;
rEXTREN = null;
vid_rascheta= null;
RKSG = null;         
rKOD_MES = null;
for select d.diag, d.status from diags d where d.mtl_id = :MTL_ID
into SECONDARY_DIAG, S_DIAG_STATUS do
BEGIN
if (S_DIAG_STATUS = 23) then
    RPROFNAME = ':';
else
    RPROFNAME = '. :';
rDIAG = SECONDARY_DIAG;
rCOST = 0;
suspend;
END
rCOST = iCOST;
rDOCDO = null;
rDIAG = null;
rKD = iKD;
rKDMESSROK = null;
RPROFNAME = ':';
rNMTL = null;
suspend;
END
end;
@
CREATE OR ALTER procedure SP_PROVERKI_ONCO (
    ID_ILL integer,
    NOM_MTL smallint,
    OUT_STAC date,
    STAC_DIAG varchar(7),
    ACC1 varchar(7),
    ACC2 varchar(7),
    ACC3 varchar(7),
    MTL_ONCO_STATUS smallint,
    VOZRAST integer,
    OPLAT smallint)
returns (
    OUT_ERR_STAGE smallint,
    OUT_ERR_TUMOR smallint,
    OUT_ERR_NODUS smallint,
    OUT_ERR_METAS smallint,
    OUT_ERR_DIST_METAS smallint,
    OUT_ERR_DOSE smallint,
    OUT_ERR_FRACTIONS smallint,
    OUT_ERR_DECLINE smallint,
    OUT_ERR_DATE_DECLINE smallint,
    OUT_ERR_DIAGNOSTIC_TYPE smallint,
    OUT_ERR_G_SIGN smallint,
    OUT_ERR_G_TEST smallint,
    OUT_ERR_MARKER smallint,
    OUT_ERR_M_RES smallint,
    OUT_ERR_DIRECT_DATE smallint,
    OUT_ERR_DIRECT_TYPE smallint,
    OUT_ERR_METHOD smallint,
    OUT_ERR_USLUG_TO varchar(500),
    OUT_ERR_BODY_PARAMS smallint,
    OUT_ERR_ONCO_USLUG smallint,
    OUT_ERR_ID_CAUSE smallint,
    OUT_ERR_ID_ONCO smallint,
    OUT_ERR_DIAG_DATE smallint,
    OUT_ERR_CONSILIUM smallint,
    OUT_ERR_PR_CONS smallint,
    OUT_ERR_DT_CONS smallint,
    OUT_ERR_U_TYPE smallint,
    OUT_ERR_ID_T_LINE smallint,
    OUT_ERR_ID_T_CYCLE smallint,
    OUT_ERR_R_TYPE smallint,
    OUT_ERR_ONCO_MEDICALS smallint,
    OUT_ERR_CODE_DRUG smallint,
    OUT_ERR_CODE_SCHEM smallint,
    OUT_ERR_DATE_INJ smallint,
    OUT_ERR_BSA smallint,
    OUT_ERR_WEIGHT smallint,
    OUT_ERR_HEIGHT smallint,
    OUT_ERR_SURG_TYPE smallint,
    OUT_ERR_VID_VME smallint)
as
declare variable P_ID_ONCO integer;
declare variable P_ID_CAUSE smallint;
declare variable P_ID_STAGE smallint;
declare variable P_ID_TUMOR smallint;
declare variable P_ID_NODUS smallint;
declare variable P_ID_METAS smallint;
declare variable P_DIST_METAS smallint;
declare variable P_DOSE numeric(3,2);
declare variable P_ID_DEC smallint;
declare variable P_DATE_DEC date;
declare variable P_DIAG_TYPE smallint;
declare variable P_ID_G_S smallint;
declare variable P_ID_G_T smallint;
declare variable P_ID_MARK smallint;
declare variable P_ID_M_R smallint;
declare variable P_G_S_CHECK smallint;
declare variable P_G_T_CHECK smallint;
declare variable P_MARK_CHECK smallint;
declare variable P_M_RES_CHECK smallint;
declare variable P_DIR_TYPE smallint;
declare variable P_METHOD smallint;
declare variable P_USLUG_TO varchar(20);
declare variable P_DATE_DIR date;
declare variable P_REC_RSLT smallint;
declare variable P_DIAG_DATE date;
declare variable P_FRACTIONS smallint;
declare variable P_WEIGHT numeric(3,1);
declare variable P_HEIGHT smallint;
declare variable P_BSA numeric(3,1);
declare variable P_ID_ILL integer;
declare variable P_NOM_MTL smallint;
declare variable P_PR_CONS smallint;
declare variable P_DT_CONS date;
declare variable P_ID_ONC_USL integer;
declare variable P_ID_U_TYPE smallint;
declare variable P_ID_SURGERY smallint;
declare variable P_ID_T_LINE smallint;
declare variable P_ID_T_CYCLE smallint;
declare variable P_ID_R_TYPE smallint;
declare variable P_CODE_DRUG varchar(6);
declare variable P_CODE_SCHEM varchar(10);
declare variable P_DATE_ONJ date;
declare variable P_REQ_U_TYPE smallint;
declare variable P_MTL_START date;
declare variable P_MTL_FINISH date;
declare variable P_USL_TIP34 smallint;
begin
OUT_ERR_STAGE = 0;
OUT_ERR_TUMOR = 0;
OUT_ERR_NODUS = 0;
OUT_ERR_METAS = 0;
OUT_ERR_DIST_METAS = 0;
OUT_ERR_DOSE = 0;
OUT_ERR_DECLINE = 0;
OUT_ERR_DATE_DECLINE = 0;
OUT_ERR_DIAGNOSTIC_TYPE = 0;
OUT_ERR_G_SIGN = 0;
OUT_ERR_G_TEST = 0;
OUT_ERR_MARKER = 0;
OUT_ERR_M_RES = 0;
OUT_ERR_DIRECT_DATE = 0;
OUT_ERR_DIRECT_TYPE = 0;
OUT_ERR_METHOD = 0;
OUT_ERR_USLUG_TO = '';
OUT_ERR_FRACTIONS = 0;
OUT_ERR_BODY_PARAMS = 0;
OUT_ERR_ID_CAUSE = 0;
OUT_ERR_ID_ONCO = 0;
OUT_ERR_DIAG_DATE = 0;
OUT_ERR_PR_CONS = 0;
OUT_ERR_DT_CONS = 0;
OUT_ERR_U_TYPE = 0;
OUT_ERR_SURG_TYPE = 0;
OUT_ERR_ID_T_LINE = 0;
OUT_ERR_ID_T_CYCLE = 0;
OUT_ERR_R_TYPE = 0;
OUT_ERR_CODE_DRUG = 0;
OUT_ERR_CODE_SCHEM = 0;
OUT_ERR_DATE_INJ = 0;
OUT_ERR_BSA = 0;
OUT_ERR_WEIGHT = 0;
OUT_ERR_HEIGHT = 0;
if (MTL_ONCO_STATUS = 1) then --   
begin
OUT_ERR_ONCO_USLUG = 1;
OUT_ERR_CONSILIUM = 1;
OUT_ERR_VID_VME = 1;
select ONC.ID_ONCO, ONC.ID_ILL, ONC.NOM_MTL, M.STARTD, M.FINISH, ONC.ID_CAUSE, ONC.ID_STAGE, ONC.ID_TUMOR, ONC.ID_NODUS, ONC.ID_METAS,
ONC.DIST_METAS, ONC.DOSE, ONC.FRACTIONS, ONC.WEIGHT, ONC.HEIGHT, ONC.BSA--, iif(C.ID_CONS is not null, 1, 0) IS_CONS
from ONCOLOGY ONC
join MTL M on M.ID_ILL=ONC.ID_ILL and M.NOM_MTL=ONC.NOM_MTL
--left join CONSILIUM C on C.ID_ILL=M.ID_ILL and C.NOM_MTL=M.NOM_MTL
where ONC.ID_ILL = :ID_ILL and
ONC.NOM_MTL = :NOM_MTL
into :P_ID_ONCO, :P_ID_ILL, :P_NOM_MTL, :P_MTL_START, :P_MTL_FINISH, :P_ID_CAUSE, :P_ID_STAGE, :P_ID_TUMOR, :P_ID_NODUS, :P_ID_METAS, :P_DIST_METAS,
:P_DOSE, :P_FRACTIONS, :P_WEIGHT, :P_HEIGHT, :P_BSA;--, :P_IS_CONSILIUM;
-------------------------------------------
if (:P_ID_ONCO is null) then
OUT_ERR_ID_ONCO = 1; --      - 
else
begin
if (:P_ID_CAUSE is null) then
OUT_ERR_ID_CAUSE = 1;
if (P_BSA > 6) then OUT_ERR_BSA = 1;
if (P_WEIGHT > 500) then OUT_ERR_WEIGHT = 2;
if (P_HEIGHT > 260) then OUT_ERR_HEIGHT = 2;
-------------------------------------------
for select ODG.DIAG_TYPE, ODG.ID_G_S, ODG.ID_G_T, ODG.ID_MARK, ODG.ID_M_R, ODG.REC_RSLT, ODG.DIAG_DATE
from ONCO_DIAGNOSTIC ODG
where ODG.ID_ONCO = :P_ID_ONCO
into :P_DIAG_TYPE, :P_ID_G_S, :P_ID_G_T, :P_ID_MARK, :P_ID_M_R, :P_REC_RSLT, :P_DIAG_DATE
do
begin
if ((:P_DIAG_DATE is null) and (coalesce(:P_DIAG_TYPE, 0) not in (1,2))) then
OUT_ERR_DIAGNOSTIC_TYPE = 1;
if (:P_DIAG_DATE is null) then
OUT_ERR_DIAG_DATE = 1;
if (:P_DIAG_TYPE = 1) then
begin
OUT_ERR_G_SIGN = 2;
OUT_ERR_G_TEST = 2;
for
select gs.id_g_s, gt.id_g_t
from SPR_ONCO_GIST_SIGNS GS
join SPR_ONCO_SIGN_TO_DIAG SD on SD.ID_G_S = GS.ID_G_S
join SPR_ONCO_GIST_TESTS GT on GT.ID_G_S = GS.ID_G_S
where (cast(:OUT_STAC as date) between GS.DATEBEG and coalesce(GS.DATEEND, '30.12.9999')) and
(cast(:OUT_STAC as date) between SD.DATEBEG and coalesce(SD.DATEEND, '30.12.9999')) and
(cast(:OUT_STAC as date) between GT.DATEBEG and coalesce(GT.DATEEND, '30.12.9999')) and
((:STAC_DIAG like SD.CODE_DIAG || '%') or (:ACC1 like SD.CODE_DIAG || '%') or (:ACC2 like SD.CODE_DIAG || '%') or (:ACC3 like SD.CODE_DIAG || '%'))
into :P_G_S_CHECK, P_G_T_CHECK
do
begin
if (:P_ID_G_S = :P_G_S_CHECK) then
OUT_ERR_G_SIGN = 0;
if ((:P_ID_G_T = :P_G_T_CHECK)) then
OUT_ERR_G_TEST = 0;
end
if (:P_ID_G_S is null) then
OUT_ERR_G_SIGN = 1;
if (:P_ID_G_T is null) then
begin
if (coalesce(:P_REC_RSLT, 0) = 1) then
OUT_ERR_G_TEST = 1;
else
OUT_ERR_G_TEST=0;
end
end
if (:P_DIAG_TYPE = 2) then
begin
OUT_ERR_MARKER = 2;
OUT_ERR_M_RES = 2;
for
select MK.ID_MARK, MR.ID_M_R
from SPR_ONCO_MARKERS MK
join SPR_ONCO_MARK_TO_DIAG MD on MD.ID_MARK = MK.ID_MARK
join SPR_ONCO_MARKER_RESULTS MR on MR.ID_MARK = MK.ID_MARK
where (cast(:OUT_STAC as date) between MK.DATEBEG and coalesce(MK.DATEEND, '30.12.9999')) and
(cast(:OUT_STAC as date) between MD.DATEBEG and coalesce(MD.DATEEND, '30.12.9999')) and
(cast(:OUT_STAC as date) between MR.DATEBEG and coalesce(MR.DATEEND, '30.12.9999')) and
((:STAC_DIAG like MD.CODE_DIAG || '%') or (:ACC1 like MD.CODE_DIAG || '%') or (:ACC2 like MD.CODE_DIAG || '%') or (:ACC3 like MD.CODE_DIAG || '%'))
into :P_MARK_CHECK, :P_M_RES_CHECK
do
begin
if (:P_ID_MARK = :P_MARK_CHECK) then
OUT_ERR_MARKER = 0;
if (:P_ID_M_R = :P_M_RES_CHECK) then
OUT_ERR_M_RES = 0;
end
if (:P_ID_MARK is null) then
OUT_ERR_MARKER = 1;
if (:P_ID_M_R is null) then
begin
if (coalesce(:P_REC_RSLT, 0) = 1) then
OUT_ERR_M_RES = 1;
else
OUT_ERR_M_RES = 0;
end
end
end
for select ODC.ID_DEC, ODC.DATE_DEC
from ONCO_DECLINE ODC
where ODC.ID_ONCO = :P_ID_ONCO
into :P_ID_DEC, :P_DATE_DEC
do
begin
if (:P_ID_DEC is null) then
OUT_ERR_DECLINE = 1;
if (:P_DATE_DEC is null) then
OUT_ERR_DATE_DECLINE = 1;
end
--------------------------------------------
if ((select iif(T.ID_IN_RANGE <> 0, 1, null) IS_IN
from (select first 1 ST.CODE_DIAG, sum(iif(:P_ID_STAGE = ST.ID_STAGE, 1, 0)) ID_IN_RANGE
from SPR_ONCO_STAGES ST
where ((:OUT_STAC) between ST.DATEBEG and coalesce(ST.DATEEND, '31.12.9999')) and
(((:STAC_DIAG like ST.CODE_DIAG || '%') ) --or (:ACC1 like ST.CODE_DIAG || '%') or (:ACC2 like ST.CODE_DIAG || '%') or (:ACC3 like ST.CODE_DIAG || '%')
or (ST.CODE_DIAG is null))
group by ST.CODE_DIAG
order by ST.CODE_DIAG desc) T) is null) then --     NULL
OUT_ERR_STAGE = 2;
if (:P_ID_STAGE is null) then
begin
if (((OPLAT = 1) and (coalesce(:P_ID_CAUSE, -1) in (0,1,2,3,4)))
or
((OPLAT = 6) and (coalesce(:P_ID_CAUSE, -1) in (0,1,2)))) then
OUT_ERR_STAGE = 1;
else
OUT_ERR_STAGE = 0;
end
--------------------------------------------
if ((select iif(T.ID_IN_RANGE <> 0, 1, null) IS_IN
from (select first 1 TM.CODE_DIAG, sum(iif(:P_ID_TUMOR = TM.id_TUMOR, 1, 0)) ID_IN_RANGE
from SPR_ONCO_TUMOR TM
where ((:OUT_STAC) between TM.DATEBEG and coalesce(TM.DATEEND, '31.12.9999')) and
(((:STAC_DIAG like TM.CODE_DIAG || '%') ) --or (:ACC1 like TM.CODE_DIAG || '%') or (:ACC2 like TM.CODE_DIAG || '%') or (:ACC3 like TM.CODE_DIAG || '%')
or (TM.CODE_DIAG is null))
group by TM.CODE_DIAG
order by TM.CODE_DIAG desc) T) is null) then --     NULL
OUT_ERR_TUMOR = 2;
if (:P_ID_TUMOR is null) then
begin
if ((coalesce(:P_ID_CAUSE, -1) = 0) and (:VOZRAST >= 18)) then
OUT_ERR_TUMOR = 1;
else
OUT_ERR_TUMOR = 0;
end
--------------------------------------------
if ((select iif(T.ID_IN_RANGE <> 0, 1, null) IS_IN
from (select first 1 ND.CODE_DIAG, sum(iif(:P_ID_NODUS = ND.ID_NODUS, 1, 0)) ID_IN_RANGE
from SPR_ONCO_NODUS ND
where ((:OUT_STAC) between ND.DATEBEG and coalesce(ND.DATEEND, '31.12.9999')) and
(((:STAC_DIAG like ND.CODE_DIAG || '%') ) --or (:ACC1 like ND.CODE_DIAG || '%') or (:ACC2 like ND.CODE_DIAG || '%') or (:ACC3 like ND.CODE_DIAG || '%')
or (ND.CODE_DIAG is null))
group by ND.CODE_DIAG
order by ND.CODE_DIAG desc) T) is null) then --     NULL
OUT_ERR_NODUS = 2;
if (:P_ID_NODUS is null) then
begin
if ((coalesce(:P_ID_CAUSE, -1) = 0) and (:VOZRAST >= 18)) then
OUT_ERR_NODUS = 1;
else
OUT_ERR_NODUS = 0;
end
--------------------------------------------
if ((select iif(T.ID_IN_RANGE <> 0, 1, null) IS_IN
from (select first 1 MT.CODE_DIAG, sum(iif(:P_ID_METAS = MT.ID_METAS, 1, 0)) ID_IN_RANGE
from SPR_ONCO_METAS MT
where ((:OUT_STAC) between MT.DATEBEG and coalesce(MT.DATEEND, '31.12.9999')) and
(((:STAC_DIAG like MT.CODE_DIAG || '%')) --or (:ACC1 like MT.CODE_DIAG || '%') or (:ACC2 like MT.CODE_DIAG || '%') or (:ACC3 like MT.CODE_DIAG || '%')
or (MT.CODE_DIAG is null))
group by MT.CODE_DIAG
order by MT.CODE_DIAG desc) T) is null) then --     NULL
OUT_ERR_METAS = 2;
if (:P_ID_METAS is null) then
begin
if ((coalesce(:P_ID_CAUSE, -1) = 0) and (:VOZRAST >= 18)) then
OUT_ERR_METAS = 1;
else
OUT_ERR_METAS = 0;
end
--    ,      0  1
--------------------------------------------
if ((coalesce(P_ID_CAUSE, -1) in (1,2)) and (coalesce(:P_DIST_METAS, 0) not in (0,1))) then
OUT_ERR_DIST_METAS = 1;
if ((coalesce(P_ID_CAUSE, -1) not in (1,2)) and (:p_dist_metas is not null)) then
OUT_ERR_DIST_METAS = 2;
--------------------------------------------
p_usl_tip34 = 0;
for select ou.id_onc_usl, ou.id_u_type, ou.id_surgery, ou.id_t_line, ou.id_t_cycle, ou.id_r_type
from onco_uslug ou
where ou.id_onco=:p_id_onco
into :P_ID_ONC_USL, :P_ID_U_TYPE, :P_ID_SURGERY, :P_ID_T_LINE, :P_ID_T_CYCLE, :P_ID_R_TYPE do
begin
OUT_ERR_ONCO_USLUG = 0;
OUT_ERR_ONCO_MEDICALS = 1;
if (:P_ID_U_TYPE is null) then
OUT_ERR_U_TYPE = 1;
else
if ((:P_ID_U_TYPE in (1,3,4) and (oplat <> 6)) or
((:P_ID_U_TYPE in (1,3,4,6) and (oplat = 6))) and
(not exists(select o.vid_vme from operat o where o.id_ill = :ID_ILL and o.nom_mtl = :nom_mtl and coalesce(o.vid_vme, '') = ''))) then
begin
OUT_ERR_VID_VME = 0;
end
if (:P_ID_U_TYPE = 1) then
begin
if (:P_ID_SURGERY is null) then
OUT_ERR_SURG_TYPE = 1;
if (not exists(select O.ID
from OPERAT O
where O.ID_ILL = :ID_ILL and
((upper(left(O.USLUG, 3)) = 'A16') or
(exists(select *
from SPR_USLUG U
where U.USLUG = trim(O.USLUG) and
U.type = 1))))) then
OUT_ERR_SURG_TYPE = 2;
end
else
if (:p_id_surgery is not null) then
OUT_ERR_SURG_TYPE = 3;
if (:P_ID_U_TYPE = 2) then
begin
if (:P_ID_T_LINE is null) then
OUT_ERR_ID_T_LINE = 1;
if (:P_ID_T_CYCLE is null) then
OUT_ERR_ID_T_CYCLE = 1;
end
else
begin
if (:p_id_t_line is not null) then
OUT_ERR_ID_T_LINE = 2;
if (p_id_t_cycle is not null) then
OUT_ERR_ID_T_CYCLE = 2;
end
if (:P_ID_U_TYPE in (3,4)) then
begin
if (:P_DOSE is null) then
OUT_ERR_DOSE = 1; --   ,      
if (:P_FRACTIONS is null) then
OUT_ERR_FRACTIONS = 1; --   ,      
if (:P_ID_R_TYPE is null) then
OUT_ERR_R_TYPE = 1;
p_usl_tip34 = 1;
end
else
if (:P_ID_R_TYPE is not null) then
OUT_ERR_R_TYPE = 2;
for select OM.CODE_DRUG, OM.CODE_SCHEM, OM.DATE_INJ, SC.ID_U_TYPE
from ONCO_MEDICALS OM
left join SPR_CRITERIES SC on SC.CODE = OM.CODE_SCHEM and
(cast(:OUT_STAC as date) between SC.DATEBEG and coalesce(SC.DATEEND, '31.12.9999'))
where OM.ID_ONC_USL = :P_ID_ONC_USL
into :P_CODE_DRUG, :P_CODE_SCHEM, :P_DATE_ONJ, :P_REQ_U_TYPE
do
begin
OUT_ERR_ONCO_MEDICALS = 0;
if (coalesce(:P_CODE_DRUG, '') = '') then
OUT_ERR_CODE_DRUG = 1;
if (coalesce(:P_CODE_SCHEM, '') = '') then
OUT_ERR_CODE_SCHEM = 1;
if  ((:vozrast >= 18) and
(left(:STAC_DIAG, 3) between 'C00' and 'C80') or (left(:STAC_DIAG, 3) between 'C97' and 'D09')) then
begin
if ((:P_ID_U_TYPE = 2) and
not(lower(left(coalesce(:P_CODE_SCHEM, ''), 5)) between 'sh001' and 'sh904' or
    lower(left(coalesce(:P_CODE_SCHEM, ''), 6)) between 'sh0001' and 'sh9004')) then
OUT_ERR_CODE_SCHEM = 2;
if ((:P_ID_U_TYPE = 4) and
not((lower(left(coalesce(:P_CODE_SCHEM, ''), 5)) between 'sh001' and 'sh904') or
    (lower(left(coalesce(:P_CODE_SCHEM, ''), 6)) between 'sh0001' and 'sh9004') or
    (lower(left(coalesce(:P_CODE_SCHEM, ''), 5)) between 'mt001' and 'mt017'))) then
OUT_ERR_CODE_SCHEM = 2;
end
if ((lower(coalesce(:P_CODE_SCHEM, '')) = lower('')) and
(left(:STAC_DIAG, 3) not between 'C81' and 'C96') and
(:vozrast >= 18)) then
OUT_ERR_CODE_SCHEM = 3;
if (:P_DATE_ONJ is null) then
OUT_ERR_DATE_INJ = 1;
if ((:P_REQ_U_TYPE is not null) and (:P_REQ_U_TYPE <> :P_ID_U_TYPE)) then
OUT_ERR_CODE_SCHEM = 4;
end
if (:P_ID_U_TYPE not in (2,4)) then --  .     
begin
if (OUT_ERR_ONCO_MEDICALS = 1) then
OUT_ERR_ONCO_MEDICALS = 0;  --        
if ((:P_BSA is not null) and ((:P_WEIGHT is null) or (:P_HEIGHT is null))) then
OUT_ERR_BODY_PARAMS = 1; --       
end
--if (:P_ID_U_TYPE in (2,4)) then --.     
--begin
--if ((:P_WEIGHT is null) or (:P_HEIGHT is null) or (:P_BSA is null)) then
--OUT_ERR_BODY_PARAMS = 1; --       
--end
end
if ((P_DOSE is not null) and (p_usl_tip34 <> 1)) then OUT_ERR_DOSE = 2;
if ((P_FRACTIONS is not null) and (p_usl_tip34 <> 1)) then OUT_ERR_FRACTIONS = 2;
--------------------------------------------
if ((OUT_ERR_ONCO_USLUG = 1) and (p_id_cause not in (0,1,2))) then
OUT_ERR_ONCO_USLUG = 0; --     ,      
--------------------------------------------
if (OUT_ERR_ONCO_USLUG <> 0) then --           
OUT_ERR_ONCO_MEDICALS = 0;
--------------------------------------------
--if (P_IS_CONSILIUM = 0) then
for select oc.id_cons, con.dt_cons from consilium con
left join spr_onco_consilium oc on oc.id_cons = con.pr_cons and
:out_stac between oc.datebeg and coalesce(oc.dateend, '31.12.9999')
where CON.ID_ILL = :P_ID_ILL and CON.NOM_MTL = :P_NOM_MTL
into :P_PR_CONS, :P_DT_CONS
do
begin
OUT_ERR_CONSILIUM = 0;
if (:P_PR_CONS is null) then
OUT_ERR_PR_CONS = 1;
if ((:P_DT_CONS is null) and (coalesce(:P_PR_CONS, -1) in (1, 2, 3))) then
OUT_ERR_DT_CONS = 1;
if ((OUT_ERR_DT_CONS = 0) and (:P_DT_CONS > :P_MTL_FINISH)) then
OUT_ERR_DT_CONS = 2;
end
end
end
----------------------------------------
for
select od.dir_type, od.method, od.uslug_to, od.date_dir from onco_direction od
where od.id_ill=:id_ill and od.nom_mtl=:nom_mtl
into :P_DIR_TYPE, :P_METHOD, :P_USLUG_TO, :P_DATE_DIR
do
begin
if (:P_DATE_DIR is null) then
OUT_ERR_DIRECT_DATE = 1;
if (not(P_DATE_DIR between P_MTL_START and P_MTL_FINISH)) then
OUT_ERR_DIRECT_DATE = 2;
if (:P_DIR_TYPE is null) then
OUT_ERR_DIRECT_TYPE = 1;
if ((:P_DIR_TYPE = 3) and (:P_METHOD is null)) then
OUT_ERR_METHOD = 1;
if (:P_METHOD is not null) then
begin
if (:P_USLUG_TO is null) then
OUT_ERR_USLUG_TO = 'empty';
else if ((OUT_ERR_USLUG_TO <> 'empty') and (not exists(select * from spr_fys f where f.kod_usl_mz = :P_USLUG_TO))) then
OUT_ERR_USLUG_TO = iif(trim(OUT_ERR_USLUG_TO) = '', :P_USLUG_TO, trim(OUT_ERR_USLUG_TO) || ', ' || :P_USLUG_TO);
end
end
suspend;
end;
@
CREATE OR ALTER procedure GET_INFO_SLUCH (
    IDCASE integer,
    PR_NOV smallint)
returns (
    SUMV numeric(15,2),
    POLIS varchar(30),
    NHISTORY varchar(50),
    DATE_1 date,
    DATE_2 date,
    DS varchar(10),
    USL_OK varchar(200),
    DR date)
as
begin
select
SUM_SF, trim(trim(s.seria)||' '||trim(s.number)) polis, s.nomib, s.in_stac, s.out_stac, m.stac_diag,
iif(r.tip_stac=1,case r.oplat when 1 then ', '
when 6 then ', '
when 7 then ', ' end,
case r.tip_stac when 2 then '  '
when 3 then '  '
when 4 then '  ' end) ts, s.dr from stacion s
join reports r on r.repn=s.repn
join(select m1.oplat, M1.ID_ILL, sum(M1.COST_SF) SUM_SF, max(m1.id) max_mtl_id_per_oplat
from MTL M1
group by m1.oplat, M1.ID_ILL) T1 on T1.ID_ILL = s.ID_ILL and t1.oplat = r.oplat
join MTL M on m.id = t1.max_mtl_id_per_oplat
where s.id_ill=:idcase and r.pr_nov = :PR_NOV
into :sumv, :polis, :nhistory, :date_1, :date_2, :ds, :usl_ok, :dr;
suspend;
end;
@
COMMIT WORK;